import {
	Mode
} from '@jupyterlab/codemirror'

import CodeMirror from 'codemirror';

import 'codemirror/mode/python/python';
import 'codemirror/addon/mode/multiplex';

declare module 'codemirror' {
	function multiplexingMode(x: CodeMirror.Mode<any>, ...others: object[]): CodeMirror.Mode<any>;
	var modeInfo: any[];
}	

CodeMirror.defineMode("finesse", (config) => {
	let pmode = CodeMirror.getMode(config, "python");
	return CodeMirror.multiplexingMode(
		pmode,
		{
			open: '#katcode',
			close: '"""',
			mode: CodeMirror.getMode(config, "text/html"),
			delimStyleOpen: "delimit",
			delimStyleClose: "string"
		}
	)
});

Mode.getModeInfo().push({
	name: 'Finesse',
	mime: "text/python",
	mode: 'finesse',
	ext: [],
});
